unit Ex23unit;

interface

uses
  Arclib,
  About,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Grids, FileCtrl;

type
  TForm1 = class(TForm)
    ArchiveContents: TListBox;
    ArchiveListBox: TFileListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Comment: TEdit;
    WriteDir: TButton;
    Exit: TButton;
    CompressedSize: TEdit;
    Size: TEdit;
    CompressedPosition: TEdit;
    Crc: TEdit;
    Date: TEdit;
    Time: TEdit;
    r: TCheckBox;
    a: TCheckBox;
    s: TCheckBox;
    h: TCheckBox;
    d: TCheckBox;
    Level: TEdit;
    ArchiveComment: TEdit;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ArchiveListBoxChange(Sender: TObject);
    procedure ArchiveContentsClick(Sender: TObject);
    procedure CommentChange(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure WriteDirClick(Sender: TObject);
    procedure ArchiveCommentChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Z : ALZipDir;
  Busy : boolean;
  Count : integer;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  z := nil;
  busy := false;
end;

procedure TForm1.ArchiveListBoxChange(Sender: TObject);
var
  error : integer;
  i : integer;
begin
  if not Busy then
  begin
    ArchiveContents.Clear;
    if ArchiveListBox.ItemIndex > -1 then
    begin
      Busy := true;
      if Z <> nil then ALFreeDir( Z );
      Z := ALReadDir( ArchiveListBox.Items[ ArchiveListBox.ItemIndex ], Count, error );
      ArchiveContents.Clear;
      if (Z <> nil) and (error = AL_SUCCESS) then
        for i := 0 to count - 1 do
          ArchiveContents.Items.Add( Z^[i].name );
      ArchiveComment.Text := Z^[count].comment;
      Busy := false;
    end;
  end
end;

function DateString( month : integer;
                     date  : integer;
                     year : integer ) : string;
var
  m : string;
  d : string;
  y : string;
begin
    Str( month:2, m );
    Str( date:2, d );
    Str( year:4, y );
    DateString := m + '/' + d + '/' + y;
end;

function TimeString( hour : integer;
                     minute : integer;
                     second : integer ) : string;
var
  h : String;
  m : string;
  s : string;
begin
    Str( hour, h );
    Str( minute, m );
    Str( second, s );
    if Length( h ) = 1 then h := '0' + h;
    if Length( m ) = 1 then m := '0' + m;
    if Length( s ) = 1 then s := '0' + s;
    TimeString := h + ':' + m + ':' + s;
end;

procedure TForm1.ArchiveContentsClick(Sender: TObject);
var
  i : integer;
begin
  i := ArchiveContents.ItemIndex;
  if ( z <> nil ) and (i <> -1 ) then
  begin
    Comment.text := z^[i].comment;
    CompressedSize.text := IntToStr( z^[i ].compressed_size );
    Size.text := IntToStr( z^[i ].size );
    CompressedPosition.text := IntToStr( z^[ i ].compressed_position );
    Crc.text := IntToHex(not z^[ i ].crc, 8 );
    Date.Text := DateString( z^[ i ].month,
                             z^[ i ].date,
                             z^[ i ].year );
    Time.Text := TimeString( z^[ i ].hour,
                             z^[ i ].minute,
                             z^[ i ].second );
    r.Checked := Boolean( z^[ i ].r );
    a.Checked := Boolean( z^[ i ].a );
    s.Checked := Boolean( z^[ i ].s );
    h.Checked := Boolean( z^[ i ].h );
    d.Checked := Boolean( z^[ i ].d );
    level.Text := IntToStr( z^[ i ].level ); 
  end
end;

procedure TForm1.CommentChange(Sender: TObject);
begin
  if ( z <> nil ) and (ArchiveContents.ItemIndex <> -1 ) then
  begin
    z^[ArchiveContents.ItemIndex].comment := Comment.Text;
  end
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.WriteDirClick(Sender: TObject);
begin
  if (not Busy) and (z <> nil) then
  begin
    Busy := true;
    ALWriteDir( z );
    Busy := false;
  end
end;

procedure TForm1.ArchiveCommentChange(Sender: TObject);
begin
  if ( z <> nil ) then
  begin
    z^[count].comment := ArchiveComment.Text;
  end
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
AboutForm.Memo1.Text := 'EX23DEL demos the simplified interface.  Double click';
AboutForm.Memo1.Lines.Add( 'on a zip file to display its contents.  Double click on a');
AboutForm.Memo1.Lines.Add( 'particular file to display its attributes.  You can change');
AboutForm.Memo1.Lines.Add( 'the zip file comment, as well as individual file comments.');
AboutForm.Show

end;

end.
