unit Ex24unit;

interface

uses
  Arclib,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl, VBXCtrl, Bigauge, Gauges;

type
  TForm1 = class(TForm)
    InputFiles: TFileListBox;
    ArchiveName: TEdit;
    Create: TButton;
    Exit: TButton;
    TextWindow: TEdit;
    ObjectProgress: TEdit;
    JobProgress: TEdit;
    ObjectGauge: TGauge;
    JobGauge: TGauge;
    ArchiveContents: TListBox;
    ReadZip: TButton;
    Append: TButton;
    Delete: TButton;
    Extract: TButton;
    About: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure CreateClick(Sender: TObject);
    procedure ObjectProgressChange(Sender: TObject);
    procedure JobProgressChange(Sender: TObject);
    procedure ReadZipClick(Sender: TObject);
    procedure TextWindowChange(Sender: TObject);
    procedure AppendClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure ExtractClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Z : ALZipDir;
  Count : Integer;
  ExtractFlag : Boolean;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Z := nil;
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.CreateClick(Sender: TObject);
var
   files : string;
   i : integer;
begin
  files := '';
  for i := 0 to InputFiles.Items.Count - 1 do
  begin
    if InputFiles.Selected[ i ] then
        files := files + ' ' + InputFiles.Items[ i ];
  end;
  Create.Enabled := false;
  Exit.Enabled := false;
  Append.Enabled := false;
  ExtractFlag := false;
  ALCreate( ArchiveName.Text,
            files,
            0,
            TextWindow.handle,
            ObjectProgress.handle,
            JobProgress.handle );
  Create.Enabled := true;
  Exit.Enabled := true;
  Append.Enabled := true;
  ReadZipClick( Form1 );
end;

procedure TForm1.ObjectProgressChange(Sender: TObject);
begin
  ObjectGauge.Progress := StrToInt( ObjectProgress.Text );
end;

procedure TForm1.JobProgressChange(Sender: TObject);
begin
  JobGauge.Progress := StrToInt( JobProgress.Text );
end;

procedure TForm1.ReadZipClick(Sender: TObject);
var
  error : integer;
  i : integer;
begin
  if Z <> nil then ALFreeDir( Z );
  Z := ALReadDir( ArchiveName.Text, Count, error );
  ArchiveContents.Clear;
  ArchiveContents.Enabled := false;
  Delete.Enabled := false;
  Extract.Enabled := false;
  if (Z <> nil) and (error = AL_SUCCESS ) then
  begin
    ArchiveContents.Enabled := true;
    Delete.Enabled := true;
    Extract.Enabled := true;
    for i := 0 to count -1 do
    begin
        ArchiveContents.Items.Add( Z^[ i ].name );
    end
  end
end;

procedure TForm1.TextWindowChange(Sender: TObject);
var
  i : integer;
begin
  if ExtractFlag then
  begin
    for i := 0 to ArchiveContents.Items.Count - 1 do
      if ArchiveContents.Items[ i ] = TextWindow.text then
      begin
         ArchiveContents.Selected[ i ] := false;
         i := ArchiveContents.Items.Count - 1; {early exit from loop}
      end
  end
  else
  begin
    for i := 0 to InputFiles.Items.Count - 1 do
      if InputFiles.Items[ i ] = TextWindow.text then
      begin
         InputFiles.Selected[ i ] := false;
         i := InputFiles.Items.Count - 1;
      end
  end
end;

procedure TForm1.AppendClick(Sender: TObject);
var
   files : string;
   i : integer;
begin
  files := '';
  for i := 0 to InputFiles.Items.Count - 1 do
  begin
    if InputFiles.Selected[ i ] then
        files := files + ' ' + InputFiles.Items[ i ];
  end;
  Append.Enabled := false;
  Create.Enabled := false;
  Exit.Enabled := false;
  ExtractFlag := false;
  ALAppend( ArchiveName.Text,
            files,
            0,
            TextWindow.handle,
            ObjectProgress.handle,
            JobProgress.handle );
  ReadZipClick( Form1 );
  Create.Enabled := true;
  Exit.Enabled := true;
  Append.Enabled := true;
end;


procedure TForm1.DeleteClick(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to ArchiveContents.Items.Count - 1 do
    Z^[ i ].mark := Integer( ArchiveContents.Selected[ i ] );
  ExtractFlag := false;
  ALDelete( Z,
            TextWindow.handle,
            ObjectProgress.handle,
            JobProgress.handle );
  ReadZipClick( Form1 );
end;

procedure TForm1.ExtractClick(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to ArchiveContents.Items.Count - 1 do
    Z^[ i ].mark := Integer( ArchiveContents.Selected[ i ] );
  ExtractFlag := true;
  ALExtract( Z,
             0,
            TextWindow.handle,
            ObjectProgress.handle,
            JobProgress.handle );
end;

end.
